//*************************************************************************************
// 	: SQ7615_RTC.c
// 汾		: V3.1
// 		: RTC ʹú
// ע		: RTC غ㼯ڱӳ  [for SQ7615_RTC_Timer]
//**************************************************************************************
#include "main.h"

unsigned char RTC_timer_actFlag;			  // RTCʱķ

//*********************************************************************
// 	: RTC_Init()
// 	: RTCʼ
// ע		:
//*********************************************************************
void RTC_Init()
{
	PCKEN6_RTC = 1;	                    	  // RTCܿ( Enable)

}


//*********************************************************************
// 	: RTC_IntEnable()
// 	: RTC ж
// ע		:
//*********************************************************************
void RTC_IntEnable(unsigned char intsel,unsigned char enable){
	__ASM("DI");							// ֹпж
	
	IER_RTC = enable;		                
	RTCCR1 = intsel;
	
	__ASM("EI");							// пж
}

//*********************************************************************
// 	: RTC_IntDisable()
// 	: RTC жϳ
// ע		:
//*********************************************************************
void RTC_IntDisable(){
	__ASM("DI");							// ֹпж
	IER_RTC = 0;		
	RTCCR1 =  0x00;              
	__ASM("EI");							// пж
}


//*********************************************************************
// 	: RTC_Start()
// 	: RTC 
// ע		:
//*********************************************************************
void RTC_Start(void)
{
	RTCCR0_RTCEN = 1;		                  // RTC 
}


//*********************************************************************
// 	: RTC_Stop()
// 	: RTC ֹͣ
// ע		:
//*********************************************************************
void RTC_Stop(void)
{
	RTCCR0_RTCEN = 0;			              // RTC ֹͣ
}

//*********************************************************************
// 	: RTC_TimerSetAndEnable()
// 	: RTC ʱ趨
// ע		: 趨ģʽRTCʱʱֵ
//*********************************************************************
void RTC_TimerSetAndEnable(void)
{
	RTCCR0 = 0x00;							  // RTC 趨
	RTCCR1 |= 0x08;							  // ʱʱж (RTCCR1_TOIE = 1)

	//RTCTMRCR_CONT = 0;					  // ʱģʽ
	RTCTMRCR_CONT = 1;						  // ʱģʽ

//--- ʱʱѡ ---// CLKSEL=00, RTCCLK = (LXTAL/8)
	//RTCTMRCR_TMRSEL = 0;					  // RTCCLK          CLKSEL=00, T=1/(LXTAL/8)	       = 244.140625us
	RTCTMRCR_TMRSEL = 1;					  // RTCCLK/64		 CLKSEL=00, T=1/[(LXTAL/8)/64]   = 15.625ms
	//RTCTMRCR_TMRSEL = 2;					  // RTCCLK/4096     CLKSEL=00, T=1/[(LXTAL/8)/4096] = 1sec
	//RTCTMRCR_TMRSEL = 3;					  // MINCLK
	
//--- RTC ʱʱֵ(ֵ0) ---//
	//RTCTMRTO = 8;				  	      	  // RTCTMRCR_TMRSEL = 1Լ125ms  (15.625ms*8=125ms)
	//RTCTMRTO = 16;				  	      // RTCTMRCR_TMRSEL = 1Լ250ms  (15.625ms*16=250ms)
	//RTCTMRTO = 24;				  	      // RTCTMRCR_TMRSEL = 1Լ375ms  (15.625ms*24=375ms)
	  RTCTMRTO = 32;				  	      // RTCTMRCR_TMRSEL = 1Լ500ms  (15.625ms*32=500ms)
	//RTCTMRTO = 40;				  	      // RTCTMRCR_TMRSEL = 1Լ625ms  (15.625ms*40=625ms)
	//RTCTMRTO = 48;				  	      // RTCTMRCR_TMRSEL = 1Լ750ms  (15.625ms*48=750ms)
	//RTCTMRTO = 56;				  	      // RTCTMRCR_TMRSEL = 1Լ875ms  (15.625ms*56=875ms)
	//RTCTMRTO = 64;				  	      // RTCTMRCR_TMRSEL = 1Լ1s     (15.625ms*64=1s)
}


//*********************************************************************
// 	: RTC_TimerStart()
// 	: RTC ʱ()
// ע		:
//*********************************************************************
void RTC_TimerStart(void)
{
	RTCTMRCR_TMREN = 1;						  // RTCʱ
}

//*********************************************************************
// 	: RTC_TimerStop()
// 	: RTCʱֹܽ(ֹͣ)
// ע		:
//*********************************************************************
void RTC_TimerStop(void)
{
	RTCTMRCR_TMREN = 0;						  // RTCʱֹܽ
	while(RTCTMRCR_TMRST != 0); 			  // 鶨ʱ״̬Ƿ޹(Ƿֹͣ?)
}


//*********************************************************************
// 	: __interrupt IntRTC()
// 	: RTC жӳ
// ע		:
//*********************************************************************
void __interrupt IntRTC(void)
{
	__asm("NOP");					    	  // ָ

/*	
	//--- ж(ÿж) ---
	if (RTCCR1_SECF == 1 )			    	  // жϷ
	{
		RTCCR1 = (RTCCR1&0x0F)|0x40;    	  // жϱ
		
		RTC_1sec_actFlag = 1;				  // Oÿķ
		LED1_out = ~LED1_out;
		
	}
*/
	
/* 	
	//--- ж ---
	if(RTCCR1_ALF == 1)						  // жϷ
	{
		RTCCR1 = (RTCCR1&0x0F)|0x20;		  // жϱ־
		
		RTC_alarm_actFlag = 1;				  // Oӵķ
	} 
*/
	


	//--- ʱʱж ---
	if (RTCCR1_TOF == 1)			    	  // ʱʱжϷ
	{
		RTCCR1 = (RTCCR1&0x0F)|0x80;		  // ʱʱжϱ
		RTC_timer_actFlag = 1;				  // ORTCʱķ
		LED1_out = ~LED1_out;
	}

	
}


