//SQ7615_DVO
//*************************************************************************************
// 	: main.c
// 汾		: V3.2
// 		: 
// ˵	: ΪDVOBƵ(P4.7),ʼDVOBƵΪ: 3.906 KHz ,LED1  (P2.0)
//			  1. °1 BTN1_in(P3.0)ֹͣDVOB  LEDȫ
//            2. °2 BTN2_in(P3.1)趨һDVOBƵʣDVOB
//			  3. °3 BTN3_in(P3.2)趨һDVOBƵʣDVOB
//
//			  4DVOB֮Ƶ:
//			  Freq_Out_Case = 1, DVOBƵΪ: 3.906 KHz  LED1  (P2.0)
//			  Freq_Out_Case = 2, DVOBƵΪ: 7.812 KHz  LED2  (P2.1)
//			  Freq_Out_Case = 3, DVOBƵΪ:15.625 KHz  LED3  (P2.2)
//			  Freq_Out_Case = 4, DVOBƵΪ:31.25  KHz  LED4  (P2.4)
//  
// ע		: []
//	 					 1  BTN1_in(P3.0)
//						 2  BTN2_in(P3.1)
//						 3  BTN3_in(P3.2)
//
//			  [LED]	 LED1  (P2.0)
//			  			 LED2  (P2.1)
//			  			 LED3  (P2.2)
// 						 LED4  (P2.4)
//**************************************************************************************
#ifndef	IO_MEM
#define	IO_MEM
#endif
#include "main.h"

/* ----------------------  -------------------------- */
static unsigned char Main_State;
unsigned char Index;

unsigned char Freq_Out_Case;

const DVOB_FREQ_MODE DVOB_Freq_Mode[4]={
	  DVOB_FCGCK_DIV_4096,                                            
	  DVOB_FCGCK_DIV_2048,
      DVOB_FCGCK_DIV_1024,	
	  DVOB_FCGCK_DIV_512
};
//---------------------------------------------------------------

void Freq_Out_Case_Satus_LED(){  // DVOBƵcase,Ӧcase LEDƺ
	if(DVOCR_DVOEN == 0){
	   P2DO = 0xFF; // LEDȫ
	}
	else if(DVOCR_DVOEN){
	        if(Freq_Out_Case==1){
			__ASM("NOP");    // ָ
				P2DO = 0xFE; // 1111 1110   LED1  (P2.0)
			}
			else if(Freq_Out_Case==2){
			__ASM("NOP");    // ָ	

				P2DO = 0xFD; //  1111 1101  LED2  (P2.1) 
			}
			else if(Freq_Out_Case==3){
			__ASM("NOP");    // ָ	
				P2DO = 0xFB; //  1111 1011  LED3  (P2.2)
			}							
			else if(Freq_Out_Case==4){
			__ASM("NOP");    // ָ	
				P2DO = 0xE7; //  1110 1111  LED4  (P2.4)
			}
	}

}



/* -----------------------  --------------------------- */
void main()
{
/* ---------------------- ϵͳʼ ------------------------ */
	CLKCR1_HIRCEN  = 1;                     //  HIRC
	while(CLKCR1_HIRCRDY ==0);				// ȴ HIRC 
	CLKCR0_SCKPSC = 0x00;                   // ϵͳƵʳ1   (16M/1=16MHz) 
 	CLKCR0_SCKSRC = 0;                      // ʱԴлHIRC
	while(CLKCR0_SCKRDY ==0);				// ȴ ϵͳʱ 
/* ---------------------- ܽųʼ ------------------------ */
    P2OE  = 0x17;                        	// 趨P2.0,P2.1,P2.2 P2.4ܽΪ
    P3OE  = 0x00;                        	// 趨P3.0,P3.1,P3.2 ܽΪ
	P3PU |= 0x07;                       	// 趨P3.0,P3.1,P3.2 
	LED1_out = 1;							// ʼ趨LED1Ϊ״̬
	LED2_out = 1;							// ʼ趨LED2Ϊ״̬
	LED3_out = 1;							// ʼ趨LED3Ϊ״̬
	LED4_out = 1;							// ʼ趨LED4Ϊ״̬
/* ---------------------- EINT ʼ ------------------------ */
	EINT_Init();                        	// EINT ʼ趨
	EINT_IntEnable();                   	// ⲿжEINT	
/* ---------------------- DVOB ʼ ----------------- */
	DVOB_Init();							// DVOBʼ,DVOBƵʳƵѡcase1 ϵͳƵ4096
	DVOB_Start();							// DVOB
	
	if(DVOCR_DVOEN){
	LED1_out = 0;							// LED1
	Index = 1;
	Freq_Out_Case = 1;
	}
	//----------------------------------------------------------
	Main_State = STATE_WAIT_KEY;			// ʼ״̬Ϊȴ
	//----------------------------------------------------------
    while(1){
        switch(Main_State){
			case STATE_WAIT_KEY:			    	  	  // ״̬Ϊȴ

					if(Push_BTN1_Flag){					  // 1_ ֮ⲿж Ϊ1
						Push_BTN1_Flag = 0; 	  		  // 1_ ֮ⲿж				
							DVOB_Stop();  				  // DVOBֹͣ;
							
							if(DVOCR_DVOEN == 0){
								LED1_out = 1;
								LED2_out = 1;
								LED3_out = 1;
								LED4_out = 1;
							}
							Main_State = STATE_WAIT_KEY;		
					}
					
					else if(Push_BTN2_Flag){	
						Push_BTN2_Flag = 0; 	  		  // 2_ ֮ⲿж
						DVOB_Stop();  				  	  // DVOBֹͣ;
						Index++;
						__ASM("NOP");					  // ָ
						
						if(Index > DVOB_FCGCK_DIV_512)	  // Index>4
						Index = DVOB_FCGCK_DIV_4096;   
						Freq_Out_Case = DVOB_Freq_Mode[Index-1];
						
						
						Main_State = STATE_SET_FREQ;
						DVOB_Start();
						__ASM("NOP");				      // ָ
					}			
					
					else if(Push_BTN3_Flag){	
						Push_BTN3_Flag = 0; 	  		  // 3_ ֮ⲿж
						DVOB_Stop();  				      // DVOBֹͣ;
				
						if (Index!=0){
							Index--;
						}
						else{
							Index =1;
						
						}
						__ASM("NOP");					  // ָ
						
                		if(Index < DVOB_FCGCK_DIV_4096)						
                		Index = DVOB_FCGCK_DIV_512;
  						Freq_Out_Case = DVOB_Freq_Mode[Index-1];
						
						
						Main_State = STATE_SET_FREQ;
						DVOB_Start(); 		   						   
					}
					__ASM("NOP");				          // ָ
			break;
			
			//-------------------------------------------------------------------
			case STATE_SET_FREQ:				      	  // ״̬Ϊһ״̬֮ѡ趨DVOBƵģʽ
			switch(Freq_Out_Case){
					case DVOB_FCGCK_DIV_4096:  			  // fsysclk=16MHz,趨DVOBƵΪfsysclk/4096, s3.906 KHz
						TBTCR_DV9CK = 0;
						DVOCR_DVOCK = 0;
					    Freq_Out_Case_Satus_LED();		  // DVOBƵcase,Ӧcase LEDƺ
					break;

				    case DVOB_FCGCK_DIV_2048:  			  // fsysclk=16MHz,趨DVOBƵΪfsysclk/2048, s7.812 KHz
						TBTCR_DV9CK = 0;
						DVOCR_DVOCK = 1;
						Freq_Out_Case_Satus_LED();		  // DVOBƵcase,Ӧcase LEDƺ
					break;
	
					case DVOB_FCGCK_DIV_1024:  			  // fsysclk=16MHz,趨DVOBƵΪfsysclk/1024, s15.625 KHz
						TBTCR_DV9CK = 0;
						DVOCR_DVOCK = 2;
						Freq_Out_Case_Satus_LED();		  // DVOBƵcase,Ӧcase LEDƺ
					break;

					case DVOB_FCGCK_DIV_512:  			  // fsysclk=16MHz,趨DVOBƵΪfsysclk/512, s31.25  KHz
						TBTCR_DV9CK = 0;
						DVOCR_DVOCK = 3;
						Freq_Out_Case_Satus_LED();		  // DVOBƵcase,Ӧcase LEDƺ
					break;
   					
					default:
					TBTCR_DV9CK = 0;
					DVOCR_DVOCK = 0;
					Freq_Out_Case_Satus_LED();		      // DVOBƵcase,Ӧcase LEDƺ					
					
					break;	
			}	
            Main_State = STATE_WAIT_KEY_RELEASE;				
			break;
			
			//-------------------------------------------------------------------
			case STATE_WAIT_KEY_RELEASE:				  // ״̬Ϊͷ
				if((P3DI & 0x07) == 0x07){  			  // ȴͷ
				__ASM("NOP");							  // ָ
				Main_State = STATE_WAIT_KEY;			  // ͷɺ󣬻ص	ȴ֮״̬	
				}		
		    break;  
// 			
			default:
			break;		
		}	
    }
	
	
	
	
}




/* ---------------------- жϷ ------------------------ */
void __interrupt OnlyReti(void)
{
	__asm("NOP"); 							  // ָ
}

void __interrupt_n OnlyRetn(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n IntWDT(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n IntSWI(void)               // SWIλжϷ
{
	PRSTR7 = 0x5a;
	PRSTR7 = 0xa5;
	PRSTR7 = 0xc3;
	PRSTR7 = 0x3c;	
}
/* -------------------  жϷ ---------------------- */


/* -------------------- SQ7615ж ------------------ */
#pragma section const INT_VECTOR1 0xff40
void * const IntTbl1[] = {											
	OnlyReti,				/* 0xff40 : Reserved		*/									
	OnlyReti,				/* 0xff42 : Reserved		*/									
	OnlyReti,				/* 0xff44 : Reserved		*/									
	OnlyReti,				/* 0xff46 : Reserved		*/								
	OnlyReti,				/* 0xff48 : Reserved		*/									
	OnlyReti,				/* 0xff4a : Reserved		*/									
	OnlyReti,				/* 0xff4c : Reserved		*/									
	OnlyReti,				/* 0xff4e : Reserved		*/									
	OnlyReti,				/* 0xff50 : Reserved		*/									
	OnlyReti,				/* 0xff52 : Reserved		*/									
	OnlyReti,				/* 0xff54 : Reserved		*/									
	OnlyReti,				/* 0xff56 : Reserved		*/									
	OnlyReti,				/* 0xff58 : IntTCA7			*/	//жԴ:TCA7 16λʱ								
	OnlyReti,				/* 0xff5a : IntTCA6			*/	//жԴ:TCA6 16λʱ							
	OnlyReti,				/* 0xff5c : Reserved		*/									
	OnlyReti,				/* 0xff5e : Reserved		*/									
	OnlyReti,				/* 0xff60 : Reserved		*/									
	OnlyReti,				/* 0xff62 : Reserved		*/									
	OnlyReti,				/* 0xff64 : Reserved		*/									
	OnlyReti,				/* 0xff66 : Reserved		*/									
	OnlyReti,				/* 0xff68 : Reserved		*/									
	OnlyReti,				/* 0xff6a : Reserved		*/									
	OnlyReti,				/* 0xff6c : IntTX2			*/	//жԴ:UART2 TX2								
	OnlyReti,				/* 0xff6e : IntRX2			*/	//жԴ:UART2 RX2							
	OnlyReti,				/* 0xff70 : Reserved		*/									
	OnlyReti,				/* 0xff72 : Reserved		*/									
	OnlyReti,				/* 0xff74 : Reserved		*/									
	OnlyReti,				/* 0xff76 : IntTCA5			*/	//жԴ:TCA5 16λʱ								
	OnlyReti,				/* 0xff78 : IntTCA4			*/	//жԴ:TCA4 16λʱ								
	OnlyReti,				/* 0xff7a : Reserved		*/									
	OnlyReti,				/* 0xff7c : Reserved		*/									
	OnlyReti,				/* 0xff7e : Reserved		*/									
	OnlyReti,				/* 0xff80 : Reserved		*/									
	OnlyReti,		    	/* 0xff82 : Reserved		*/									
	OnlyReti,	    		/* 0xff84 : Reserved		*/									
	OnlyReti,				/* 0xff86 : Reserved		*/									
	OnlyReti,				/* 0xff88 : Reserved		*/									
	OnlyReti,				/* 0xff8a : Reserved		*/									
	OnlyReti,				/* 0xff8c : IntSIO1			*/	//жԴ:SIO 1								
	OnlyReti,				/* 0xff8e : IntI2C1			*/	//жԴ:I2C 1						
	OnlyReti,				/* 0xff90 : IntTX1			*/	//жԴ:UART1 TX1							
	OnlyReti,				/* 0xff92 : IntRX1			*/	//жԴ:UART1 RX1								
	OnlyReti,				/* 0xff94 : Reserved		*/									
	OnlyReti,				/* 0xff96 : Reserved		*/									
	OnlyReti,				/* 0xff98 : Reserved		*/									
	OnlyReti,				/* 0xff9a : IntTCA3			*/	//жԴ:TCA3 16λʱ							
	OnlyReti,				/* 0xff9c : IntTCA2			*/	//жԴ:TCA2 16λʱ								
	OnlyReti,				/* 0xff9e : Reserved		*/									
	OnlyReti,				/* 0xffa0 : IntMAC			*/	//жԴ:˷								
	OnlyReti,				/* 0xffa2 : IntEXT7			*/	//ⲿж7								
	OnlyReti,				/* 0xffa4 : IntEXT6			*/	//ⲿж6								
	OnlyReti,				/* 0xffa6 : IntEXT5			*/	//ⲿж5								
	OnlyReti,				/* 0xffa8 : IntEXT4			*/	//ⲿж4								
	OnlyReti,				/* 0xffaa : Reserved		*/									
	OnlyReti,				/* 0xffac : Reserved		*/									
	OnlyReti,				/* 0xffae : Reserved		*/							
	OnlyReti,				/* 0xffb0 : IntDIC			*/	//жԴ:DIC								
	OnlyReti,				/* 0xffb2 : Reserved		*/							
	OnlyReti,				/* 0xffb4 : Reserved		*/									
	OnlyReti,				/* 0xffb6 : Reserved		*/									
	OnlyReti,				/* 0xffb8 : Reserved		*/									
	OnlyReti,				/* 0xffba : Reserved		*/									
	OnlyReti,				/* 0xffbc : Reserved		*/									
	OnlyReti,				/* 0xffbe : Reserved		*/									
	OnlyReti,				/* 0xffc0 : Reserved		*/									
	OnlyReti,				/* 0xffc2 : Reserved		*/									
	OnlyReti,				/* 0xffc4 : IntFMC			*/	//жԴ:Flash								
	OnlyReti,				/* 0xffc6 : Reserved		*/					
	OnlyReti,				/* 0xffc8 : Reserved		*/									
	OnlyReti,				/* 0xffca : Reserved		*/									
	OnlyReti,				/* 0xffcc : Reserved		*/									
	OnlyReti,               /* 0xffce : IntADC			*/	//жԴ:ADC								
	OnlyReti,				/* 0xffd0 : IntEXT3			*/	//ⲿж3								
	IntEXT2,				/* 0xffd2 : IntEXT2			*/	//ⲿж2								
	IntEXT1,				/* 0xffd4 : IntEXT1			*/	//ⲿж1								
	IntEXT0,				/* 0xffd6 : IntEXT0			*/	//ⲿж0								
	OnlyReti,				/* 0xffd8 : IntSIO0			*/	//жԴ:SIO 0								
	OnlyReti,				/* 0xffda : IntI2C0			*/	//жԴ:I2C 0								
	OnlyReti,				/* 0xffdc : IntTX0			*/	//жԴ:UART0 TX0								
	OnlyReti,				/* 0xffde : IntRX0			*/	//жԴ:UART0 RX0								
	OnlyReti,				/* 0xffe0 : Reserved		*/									
	OnlyReti,				/* 0xffe2 : Reserved		*/									
	OnlyReti,				/* 0xffe4 : Reserved		*/									
	OnlyReti,				/* 0xffe6 : IntTCA1			*/	//жԴ:TCA1 16λʱ								
	OnlyReti,				/* 0xffe8 : IntTCA0			*/	//жԴ:TCA0 16λʱ								
	OnlyReti,				/* 0xffea : Reserved		*/									
	OnlyReti,				/* 0xffec : Reserved		*/									
	OnlyReti,			    /* 0xffee : IntRTC			*/	//жԴ:ʵʱʱRTCʱ								
	OnlyReti,				/* 0xfff0 : IntTBT			*/  //жԴ:ʱTBTʱ				
	OnlyReti,				/* 0xfff2 : Reserved		*/									
	OnlyReti,				/* 0xfff4 : IntCFD			*/	//жԴ:ʱʧЧ								
	OnlyReti,				/* 0xfff6 : IntLVD			*/	//жԴ:͵ѹLVD							
	IntWDT,					/* 0xfff8 : IntWDT			*/	//non-maskable жԴ:Źʱ		
	(void *)0xffff,			/* 0xfffa : Reserved		*/									
	IntSWI,					/* 0xfffc : IntSWI/INTUNDEF */	//non-maskable		
	STARTUP					/* 0xfffe : RESET			*/	//non-maskable			
};
#pragma section const
/* -------------------  SQ7615ж ---------------------- */

